package com.logicbig.example;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;

public class LambdaExample {
    private Runnable instanceRunnable = () -> { };

    private static Runnable staticRunnable = () -> { };

    public static void main(String[] args) throws IllegalAccessException {
        Runnable localRunnable = () -> { };
        System.out.println("-- local lambda --");
        print(localRunnable.getClass(), localRunnable);

        System.out.println("\n-- class instance lambda --");
        LambdaExample em = new LambdaExample();
        print(em.instanceRunnable.getClass(), em.instanceRunnable);

        System.out.println("\n-- class static lambda --");
        print(staticRunnable.getClass(), staticRunnable);
    }

    public static void print(Class<?> c, Object instance) throws IllegalAccessException {
        System.out.println("- constructors -");
        for (Constructor<?> constructor : c.getDeclaredConstructors()) {
            System.out.println(constructor.toGenericString());
        }
        System.out.println("- fields -");
        for (Field field : c.getDeclaredFields()) {
            System.out.printf(" field name: %s,%n field type: %s,%n field value: %s%n",
                    field.getName(),
                    field.getType(),
                    field.get(instance));
        }
    }
}